

#ifndef ELMAN_NETWORK_H
#define ELMAN_NETWORK_H
#include <annie.h>

namespace annie {

class ElmanNetwork : public TwoLayerNetwork {
  VECTOR saved_hidden;

  template<class T>
  static void append(vector<T> &a, const vector<T> &b) {
    a.resize(a.size()+b.size());
    for(int i=a.size()-b.size(); i<(int)a.size();i++)
    a[i]=b[i-a.size()+b.size()];
  }

public:

  ElmanNetwork(int inputs, int hidden, int outputs) : 
    TwoLayerNetwork(inputs+hidden,hidden,outputs), saved_hidden(hidden,0) {}

  VECTOR getOutput (VECTOR &input) {
    VECTOR i2=input;
    append(i2,saved_hidden);
    VECTOR rval = TwoLayerNetwork::getOutput(i2);
    saved_hidden =_layers[1]->getOutput();
    return rval;
  }

};
}

#endif
